/*

        GFX  head file

*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <time.h>

/* declarations */
char title[50];

/* gf declarations */

unsigned int xl,xr,yu,yb;  /* plot scaling parameters */
unsigned int xsize,ysize; /* current main window size */
unsigned int main_xpos,main_ypos; /* current window location */
float xmin,xmax,ymin,ymax;
unsigned int line_width,border_width,depth;
int line_style,cap_style,join_style;

#define MAXPOINTS 20000

float xp[MAXPOINTS],yp[MAXPOINTS];
int iv[MAXPOINTS],np;
int npmax;      /* one less than the number in the array dimension */
int dlen;         /* the data length and invec length formats */
int vlen;
int xcol;
int ycol;
char xlabel[50],ylabel[50];
char ticks;                 /* show grids (g) or ticks (t) or none (n) */
float xtick,ytick;
char filecurrent[80];
int s1;                  /* linear = 0 or log = 1 x scaling */
int s2;                  /*                       y         */
unsigned long mycolors[20];
int num_mycolors;
int fheight;       /* GF_FONT sizes */
int fwidth;         
int fdescent;
int com_col[20],com_row[20];
int num_comments;
char comments[20][100];
int xy[205];
char xzero;   /* show the x = 0 line ? */
char yzero;
float vp;      /* the variable plot size for text */
int device;   /* 1=screen, 3=post, 2=hpgl output */
int use_eof;    /* automatic, =1 is yes */
int encap;  /* default to non encapsulated post */
float sx,sy;      /* plot  sizes */

char rotp;   /* default to rotated plot output */
int cmdline;         /* is there a filename on the cmd line? 1=y */
char font[20][30];
int currfont;
float patlen;         /* pattern length for line types */
char pout[200];
char fontsused[200] ;
int linetype;         /* linetype or screen color */
FILE *fileprt;
int use_delim;     /* use delimeter charater on reads 1==yes */
char delim_char;    /* delimeter character */
float arrow_size;   /* size of invec 11&12 arrows, 0 = scale with vector */
float symbol_scale ; /* scale factor for symbols */
int psjoin; /* 0 = miter 1=round 2=bevel joins in ps output */

/* X include files */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#ifdef MSDOS
    #include <X11/cursorfo.h>
#else
    #include <X11/cursorfont.h>
#endif

/* X declarations */
Display *mydisplay;
Window mywindow;
Window root;
GC mygc;
XEvent myevent;
KeySym mykey;
XSizeHints myhint;
XTextProperty mytitle;
XTextProperty myicon;
int myscreen;
unsigned long myforeground, mybackground;
Colormap mycolormap;
Cursor mycursor;
Visual myvisual;
XColor mycolor_def;
XColor mycolor_rgb;
Font myfont;
#define GF_FONT "8x13"
/* for ps creator */
#define PROGNAME "GFx"


/*
   INPUT FORMS defns

*/
#include "../xinput/xinput.h"
#include "../xinput/menusub.h"

#define RESCALEWIN 0
#define PLOTWIN 1
#define COLSWIN 2
#define FILEWIN 3
#define PROFILEWIN 4
#define DATAWIN 5
#define COMMENTWIN 6

#define NUMWINS 7

         int plot_axes; /* 1 = yes 0 = no */
         int plot_comments; /* 1 = yes 0 = no */
         int plot_curves; /* 1 = yes 0 = no */

#define MAXSEGMENTS 99
#define MAXCOLUMNS 19

         int seg_color[MAXSEGMENTS]; /* set color */
         int seg_width[MAXSEGMENTS]; /* set width */
         int seg_pattern[MAXSEGMENTS]; /* set pattern */
         int seg_pat_len[MAXSEGMENTS]; /* set pattern length */


         int text_font[21]; /* set font for text */
         int text_color[21]; /* set font color */
         char plotfile[50];
         int plot_device; /* ps default */

         float x_plot_size;      /* plot  sizes */
         float y_plot_size;      /* plot  sizes */

int debug;

/* in gfmain.c */

int set_menu();
int do_menu(int);
int get_pos(int *,int *); /* get position of a mouse click in main win */
int x_put_comments(); /* puts comments on the X window */
int set_colors(); /* allocates the x colors uses */
int set_box(); /* sets xr,xl,yu,yb from window size */
int get_size(); /* does xgetgeo on main window, calls set box*/
int save_main_config(XEvent); /* sets main_xpos,main_ypos,xsize,ysize on configure notify */
int redraw(int); /* main window redraw, (1) -> clear win first */
int titles(); /* puts axes labels on X window */
int gf_exit(); /* frees and Closes X and exits */
int lin_fit(int ,int ,int,int ,int ,int ); /* does a linear fit on data */
int fit_locate(int row,int col,int seg,int *at,int xpos,int ypos); /* gets data index from screen position */
int usage(char *); /* prints usage */
int menu(int); /* (0) prints menu, (#>0)  does  menu item # */
int reread(); /* 'r' key command, rereads current file */
int save_gf(char *name,int xpos,int ypos);/* save to gf file */
int append_gf(char *name,int xpos,int ypos);/* append gf file */
int transform(int,float *,float *,float *,float *,float *,float *,int,int,int,int,int);
int get_default_f(char *prompt,float *x);
int get_default_i(char *prompt,int *x);
int get_default_s(char *prompt,char *x);
int get_default_c(char *prompt,char *x);
int sign(float);
void convert(char *,float x);/* puts axes floats into string */
char *lowercase(char *);
char *uppercase(char *);
/* DVI hooks */
int intigraph(); 
int dline(int);
int text (int tx,int ty,char *tt,int t);
int setpen(int);
int penup();
int pendown();
int speed(int);
int s_set_color(int);
int ulinetype(int *);
int setcolor(int);
int get_strlen(char *);
/* x specific routines */
int xline(int);
int x_y_coord(int );
int xlinetype(int);
int xtext(int x,int y,char *tt,int t);
int x_color(int *);
int plot_close_device();
int plot_open_device(char *);
int plot_out(char *);
int plot_rotate(int *,int *);

/* in gfxsubs.c */

int lin_ticks(int d,float t,float t1,float t2,int x_len,int y_len);
int log_ticks(int d,float t1,float t2,float t3,int x_len,int y_len);
int put_ticks(int d,int x,int y,int x_len,int y_len);
int rescale(int); /* (1) -> set to data limits */
int maxmin(float *xx1, float *xx2, float *yy1, float *yy2);
int parse_data(char *line,int *i1, float *x, float *y);
int chk_size(char *line);
int get_cols(char *line,int x,int y);
int auto_np(char *line);
int read_gf(char *name,int xpos,int ypos);
void strip_crlf(char *);
int x_coord(float x);
int y_coord(float y);
int wind (int *x0,int *y0,int  *x ,int  *y,int  *os);
int endpoint(int u0,int v0,int u,int v,int *f,int *xn,int *yn);
int chkpt (int i);
int symbol (int x,int y,int t1);
int draw_arrow(int x, int y,int i,int fill);
int draw_symbol(int x,int y,int t1,int d);
void time_and_date(char *);

/* in gfxinput.c */

int set_in_wins();
int put_plot_form(int win);
int plot_lists_coord(int win,int list);
int plot_lists_defaults(int win);
int plot_disables(int win);
int get_plot_form(int win);
int plot_form();
int put_rescale_form(int win);
int rescale_disables(int win);
int get_rescale_form(int win,int xpos,int ypos);
int rescale_form();
int cols_form(int *xc,int *yc,int maxcols,int xpos,int ypos);
int put_cols_form(int win,int maxcols);
int get_cols_form(int win,int *xc,int *yc);
int file_form(int mode);
int put_file_form(int win,int mode);
int get_file_form(int win,char *name);
int profile_form(int xpos,int ypos);
int profile_disables(int win);
int put_profile_form(int win);
int get_profile_form(int win);
int data_form();
int put_data_form(int win);
int data_disables(int win);
int get_data_form(int win,float *p1,float *p2,float *p3,float *p4,
              float *p5, float *p6,int *seg,int *num,int *append);
int put_comment_form(int win);
int comment_lists_coord(int win,int list);
int comment_disables(int win);
int get_comment_text(int win);
int comment_form();
int comment_add(int win);
int comment_delete(int win);
int comment_position(int win,int row,int col);
int save_center(XEvent myevent,int *xc,int *yc,int *xpos,int *ypos);

/* in gfxplot.c */

int plot(int x,int y);
void set_font (int text);
void set_linetype (int seg);
int init_plot();
void plotcurves (int i1);
void put_comments();
void show_ticks();
void box();
void psbb(float *tllx, float *tlly, float *turx, float *tury);

