#include "gfx.h"

char mod_date[]={"06/07/97"};   /* last modification date */

/*
                gfxmain.c

                needs: gfxps.c, gfxsubs.c, gfxinput.c, gfxplot.c, gfx.h
                       xinput.c xinput.h menusub.c menusub.h

                has RESCALE, PLOT, FILE, DATA forms

*/
/*

        last bug fix:  temp too short in ps_text

                %% ps comments problem and int in bounding box

                  3/9/94 fixed xmax/xmin mixup in plots

                  5/4/94 added linear curve fit

                  5/19/94 add encapsulated PS choice

                  7/20/94 added cross symbol 10

                  11/1/94 added arrow symbol 11 & 12(filled)
                        can't find windowing bug yet

                  11/2/94 wind bug needed (int)xr etc for comparisons
                           also made comment positions in X match PS
                           and fixed comment read/write inconsistancy

                  11/3/94 added color ps output. Use negative pen number
                             in multi-color input

                  11/10/94 added font and linetype lists

                  11/12/94 fixed drawing zero line ticks problem and patlen
                                setting (int->float) problem.

                  11/16/94 added data transformations

                  11/20/94 split into modules

                  11/25/94 added sup/sub etc to PS output -- Still need wysiwyg

                  07/27/95 added 'r' command to reread or refresh current file

                  08/31/95 fixed C only bug on plotting options

                  09/21/95 changed to postscript linejoin = 1, removes
                                spikyness on exp data plots

                  09/24/95... adding point and click, dropped HPGL support

                  10/08/95 added delimited data file read/write
                           (will also now write vlen=0 files)
                           continued to fix point and click bugs

                  11/12/95 corrected $ font (set f=7) in ps_text

                  11/13/95 corrected write format bug (added precision to format)
                           and made dlen limited to 7 or greater.
                           Also added XFlushes to yes_no and info window closes.
                           
                  1/21/96 changed file write g to E
                  
                  2/14/97 fixed use_eof append bug
                  
                  2/22/97 change to improved xinput routines
                  2/23/97 fixed up window placements
                  	  changed to pull down menu on main window for click
              	  2/27/97 set YES/NO defaults, added code to keep track of 
              	          window positions, removed menu_form code
              	          
              	  5/25/97 played with save_main_config, position is still
              	  	  	flakey -- fixed bad size problem.
              	  	  added num_comments=0 to read_gf was not always 
              	  	  	getting reset to zero -- added keep comments 
              	  	  	question
              	  	  made added comments always blank -- did have feature
              	  	  	that allowed deleted comments to be added back.
              	  	  added strip_crlf routine in gfxsubs.c to strip \r \n
              	  	  	from labels and comments.
              	  	  added time_and_date function to gfxsubs.c and 
              	  	  	used it in ps_initg in gfxps.c.
              	  	  moved psbb calc out of ps_initg to gfxplot.c
              	  	  
              	   6/7/97 fixed point not found in lin_fit, was iv[1]!=0 problem
*/
/*
          GfX   by T. W. Shield
                send bug reports to shield@aem.umn.edu

          Compiling: see Makefile

          Still missing:
                        gf.pro support
                        symbols in comments support (greek) DONE FOR PS ONLY
                        direct printing/plotting w/o file (unix ?)
                        top of file 'c ... ' lines transfer
                        x line type for 1-bit displays instead of color
*/



defaults()
{
/*
	sets the default values of all the settings
*/	

npmax=MAXPOINTS-1;      /* one less than the number in the array dimension */
dlen=10;          /* the data length and invec length formats */
vlen=3;
xcol=1;
ycol=2;
ticks='n';                 /* show grids (g) or ticks (t) or none (n) */
s1=0;                  /* linear = 0 or log = 1 x scaling */
s2=0;                  /*                       y         */
fheight=13;       /* should get these from x font */
fwidth=8;         /* set for 8x13 font set below */
num_comments=0;
xzero='y';   /* show the x = 0 line ? */
yzero='y';
vp=1.;      /* the variable plot size for text */
device=1;   /* 1=screen, 3=post, 2=hpgl output */
encap = 0;  /* default to non encapsulated post */
rotp='y';   /* default to rotated plot output */
cmdline=0;         /* is there a filename on the cmd line? 1=y */
currfont=2;
patlen=4.;         /* pattern length for line types */
linetype=1;         /* linetype or screen color */
use_delim=0;     /* use delimeter charater on reads 0=no */
delim_char=',';    /* delimeter character */
arrow_size = 0.7;   /* size of invec 11&12 arrows, 0 = scale with vector */
symbol_scale = 1.0 ; /* scale factor for symbols */
psjoin = 1; /* 0 = miter 1=round 2=bevel joins in ps output */

plot_axes=1; /* 1 = yes 0 = no */
plot_comments=1; /* 1 = yes 0 = no */
plot_curves=1; /* 1 = yes 0 = no */
plot_device=3; /* ps default */

x_plot_size=5.;      /* plot  sizes */
y_plot_size=4.;      /* plot  sizes */

/* set the input window structure */
set_in_wins();

/* for menus */
set_menu();

/* default data for blank window startup */

xmin =0.;
ymin = 0.;
xmax = 10.;
ymax = 10.;
strcpy(xlabel,"x axis");
strcpy(ylabel,"y axis");
ticks='n';

np = 11;

iv[1]=0;xp[1]=+.4000E+01;yp[1]= +.8000E+01;
iv[2]=1;xp[2]=+.2000E+01;yp[2]=+.8000E+01;
iv[3]=1;xp[3]=+.2000E+01;yp[3]=+.2000E+01;
iv[4]=1;xp[4]=+.4000E+01;yp[4]=+.2000E+01;
iv[5]=1;xp[5]=+.4000E+01;yp[5]=+.4000E+01;
iv[6]=1;xp[6]=+.3000E+01;yp[6]=+.4000E+01;
iv[7]=0;xp[7]=+.8000E+01;yp[7]=+.8000E+01;
iv[8]=1;xp[8]=+.6000E+01;yp[8]=+.8000E+01;
iv[9]=1;xp[9]=+.6000E+01;yp[9]=+.2000E+01;
iv[10]=0;xp[10]=+.6000E+01;yp[10]=+.6000E+01;
iv[11]=1;xp[11]=+.7500E+01;yp[11]=+.6000E+01;

}

main(argc,argv)
int argc;
char **argv;
{
int i;
char txt[10];
int done;

extern int    optind;  /* for command line options parsing */
extern char   *optarg;
char  *cmd;
char  *display = NULL;
int   c;
char *geo = NULL;
char *defgeo = "500x400+200+300";  /* default geometry for the graphics window */
int bw = 2;  /* border width, gets ignored by window manager */
int x,y,xwidth,xheight;
char hostname[50], temp[50];
int hostlen=50;
char *titleptr;
char filename[50];
char icon_name[]="gfx";
int redraw_flag = 0;
XFontStruct *font_info;

  cmd = argv[0];
  while ((c = getopt(argc, argv, "hd:g:v")) != EOF)
    switch(c)   {

    case 'd':
      display = optarg;
      break;
    case 'g':
      geo = optarg;
      break;
    case 'v':
    	debug = 1;
    	break;
    default:
    case 'h':
      usage(cmd);
      exit(0);
    }

    defaults();

/* get command line file name if there */

    if( optind < argc )
    {
        strcpy(filename,argv[optind]);
        cmdline=1;
    }


    if ((mydisplay = XOpenDisplay(display)) == NULL)
    {
    	fprintf(stderr, "Can\'t open display: %s\n", display );
    	exit(0);
    }

        /* initialization */

        myscreen = DefaultScreen(mydisplay);
        
        /* initialize input windows and menus using color and font defaults */
        
        xi_init(mydisplay,myscreen,NULL,NULL,NULL);
        ms_init(mydisplay,myscreen,NULL,NULL,NULL);


        XGeometry (mydisplay, myscreen, geo, defgeo, bw, 1, 1, 0, 0,
                        &main_xpos, &main_ypos, &xwidth,&xheight);
        xsize=xwidth;
        ysize=xheight;

        /* default pixel values */
        mybackground = WhitePixel(mydisplay,myscreen);
        myforeground = BlackPixel(mydisplay,myscreen);

        /* default program-specified window position and size */
        myhint.x=main_xpos;
        myhint.y=main_ypos;
        myhint.flags = PPosition | PSize;
        myhint.width = xsize;
        myhint.height = ysize;


        gethostname(hostname,hostlen);
        strcpy(title,"Gfx ");
        if(strlen(hostname) !=0 )
        {
                strcpy(temp,"");
                sscanf(hostname,"%[^.]",temp);
                strcat(title,temp);
        }

        /* window creation */
        mywindow = XCreateSimpleWindow(mydisplay,
                DefaultRootWindow(mydisplay),
                myhint.x, myhint.y, myhint.width, myhint.height,
                5, myforeground, mybackground);

        titleptr=title;
        XStringListToTextProperty(&titleptr,1,&mytitle);
        titleptr=icon_name;
        XStringListToTextProperty(&titleptr,1,&myicon);

        /* default program-specified window position and size */
        myhint.x=main_xpos;
        myhint.y=main_ypos;
        myhint.flags = PPosition | PSize ;
        myhint.width = xsize;
        myhint.height = ysize;

        XSetWMProperties(mydisplay,mywindow,&mytitle,&myicon,argv,argc,
                &myhint,NULL,NULL);
	
        /* GC creation and initialization */
        mygc= XCreateGC(mydisplay, mywindow, 0, NULL);
        XSetBackground(mydisplay, mygc, mybackground);
        XSetForeground(mydisplay, mygc, myforeground);

/*
        myfont = XLoadFont(mydisplay,"8x13");
*/        
        font_info = XLoadQueryFont(mydisplay,GF_FONT);
        
        myfont = font_info->fid;
        XSetFont(mydisplay,mygc,myfont);
        fwidth = font_info->max_bounds.width;
        fheight = font_info->max_bounds.ascent+font_info->max_bounds.descent;
        fdescent = font_info->max_bounds.descent;

        /* input event selection */
        XSelectInput(mydisplay,mywindow,
             ButtonPressMask | KeyPressMask | ExposureMask |
             StructureNotifyMask);

        /* window mapping */
        XMapRaised(mydisplay, mywindow);

        /* line attributes */
        line_width=1;
        line_style=LineSolid;
        cap_style=CapButt;
        join_style=JoinMiter;
        XSetLineAttributes(mydisplay,mygc,line_width,line_style,cap_style,join_style);

        get_size();

        set_colors();
        
        if(debug)
        {
        	printf("window at %i,%i\n",main_xpos,main_ypos);
        	printf("size = %ix%i \n",xsize,ysize);
        }

        /* moved for rescale change -- needs main window open */

fnf:    if(cmdline == 0)
        {
            if(file_form(1) == 2 ) gf_exit();
        }
        else
        {
            strcpy(filecurrent,filename);
            cmdline=0;
	    x = main_xpos + xsize/2;
	    y = main_ypos + ysize/2;
            if(read_gf(filename,x,y) == -1) goto fnf;  /* file not found */
        }

        plot_lists_defaults(PLOTWIN);

        redraw(0); /* for multi cols cmdline file -- event loop in cols_form
                      steals the redraw before there is anything to draw */
                   /* redraw_flag is hack to avoid extra redraw on startup */

        /* Main event-reading loop */
        done = 0;
        while( done == 0) {
                /* read the next event */
                XNextEvent(mydisplay, &myevent);
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(myevent.xexpose.count == 0)
                              {
                                  if(redraw_flag == 1)
                                       redraw(0);
                                  else
                                       redraw_flag = 1;
                              }

                        break;

                        case ConfigureNotify:
                        	save_main_config(myevent);
                                set_box();
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                        	XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:
                                do_menu(menu_window(myevent.xbutton.x_root,myevent.xbutton.y_root,0));
                        break;

                        /* process keyboard input, can be done nicer */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                if( i == 1 && txt[0] == 'q') done = 1;
                                if( i == 1 && txt[0] == '1') menu(1);
                                if( i == 1 && txt[0] == '2') menu(2);
                                if( i == 1 && txt[0] == '4') menu(4);
                                if( i == 1 && txt[0] == '5') menu(5);
                                if( i == 1 && txt[0] == '6') menu(6);
                                if( i == 1 && txt[0] == '7') menu(7);
                                if( i == 1 && txt[0] == '8') menu(8);
                                if( i == 1 && txt[0] == '9') menu(9);
                                if( i == 1 && txt[0] == 'o') menu(9);  /* plot (Output) */
                                if( i == 1 && txt[0] == 'p') menu(10); /* profile */
                                if( i == 1 && txt[0] == 'd') menu(11); /* data (transforms)*/
                                if( i == 1 && txt[0] == 't') menu(12); /* Transforms */
                                if( i == 1 && txt[0] == 'f') menu(1);  /* File */
                                if( i == 1 && txt[0] == 'c') menu(7);  /* Comments */
                                if( i == 1 && txt[0] == 'r') menu(13); /* Reload */
                                if( i == 1 && txt[0] == 's') menu(5);  /* Rescale */
                                if( i == 1 && txt[0] == 'a') menu(6);  /* Auto rescale */
                                if( i == 1 && txt[0] == 'v') 
                                {
	    				x = main_xpos + xsize/2;
	    				y = main_ypos + ysize/2;
                                	sprintf(temp,"Gfx version date %s",mod_date);
                                	info_window(x,y,temp);
                                }
                        break;
                } /* switch(myevent.type) */

                redraw_flag = 1;
        } /* while(done == 0) */


        gf_exit();
}

set_menu()
{
/* 
	for the main window click menu
	sets the text labels
*/	
	menu_info[0].num_items = 7;
	strcpy(menu_info[0].label[0],"File");
	menu_info[0].disable[0] = NO; /* enabled */
	strcpy(menu_info[0].label[1],"Rescale");
	menu_info[0].disable[1] = NO; /* enabled */
	strcpy(menu_info[0].label[2],"Comment");
	menu_info[0].disable[2] = NO; /* enabled */
	strcpy(menu_info[0].label[3],"Plot");
	menu_info[0].disable[3] = NO; /* enabled */
	strcpy(menu_info[0].label[4],"Profile");
	menu_info[0].disable[4] = NO; /* enabled */
	strcpy(menu_info[0].label[5],"Data");
	menu_info[0].disable[5] = NO; /* enabled */
	strcpy(menu_info[0].label[6],"Quit");
	menu_info[0].disable[6] = NO; /* enabled */

}

do_menu(int q)
{
/* 
	does the actions put in the menu by above sub
*/	
	if(q == 0) menu(1); /* file */
	if(q == 1) menu(5); /* rescale */
	if(q == 2) menu(7); /* comment */
	if(q == 3) menu(9); /* Plot */
	if(q == 4) menu(10); /* profile */
	if(q == 5) menu(11); /* data */
	if(q == 6) menu(4); /* quit */
	
}
	
int get_pos(int *row,int *col)
{
int done,i;
char txt[20];
/*
        returns the position of  a mouse pointer click

        returns 1 if pointer clicked

        returns -1 if q pressed

        cursor changes to cross hair for input

        includes event loop with redraw and resize
*/


        /* set cursor to crosshair */
        mycursor = XCreateFontCursor(mydisplay,XC_crosshair);
        XDefineCursor(mydisplay,mywindow,mycursor);


        /* event-reading loop to get cursor position */
        done = 0;
        while( done == 0) {
                /* read the next event */
                XNextEvent(mydisplay, &myevent);
                switch(myevent.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(myevent.xexpose.count == 0) redraw(0);

                        break;

                        case ConfigureNotify:
                        	save_main_config(myevent);
                                set_box();
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                        XRefreshKeyboardMapping(&myevent.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    *col=myevent.xmotion.x;
                                    *row=myevent.xmotion.y;
                                    done = 1;

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &myevent.xkey, txt, 10, &mykey, 0);
                                if( i == 1 && txt[0] == 'q') done = -1;
                                printf("... aborted \n");
                        break;
                } /* switch(myevent.type) */
        } /* while(done == 0) */

        /* set cursor back */

        XUndefineCursor(mydisplay,mywindow);

        return(done);
}

x_put_comments()
{
int i,l,row,col,t;

        if(num_comments < 1) return(0);

        t=1;
        x_color(&t);

        for(i=0;i<num_comments;i++)
        {
            l=strlen(comments[i]);
/*
            row = ((com_row[i]-1)*ysize)/24;
            col = ((com_col[i]-1)*xsize)/79;
*/
            col =(int)( xl + (float)((com_col[i] - 14)*((int)xr-(int)xl)) / 67.) ;
            row =(int)(  ((float)(com_row[i])/20.) * abs((int)yu - (int)yb));


            XDrawImageString( mydisplay,mywindow, mygc,col,row,
                                comments[i],l);

        }

}


set_colors()
{
/*
     could be called from sinitg which is not currently used

*/

int status,i,ncmax;
char *colorname[]={ "blue","green","red","cyan","magenta","saddle brown"};

         ncmax=6;  /* set this to the number of colors listed above */

         num_mycolors = 1;
         mycolors[0]=myforeground;   /* always use black */

         if(depth == 1)
         {
                return(0);
         }

        mycolormap = DefaultColormap(mydisplay,myscreen);

        if(depth == 4)
        {
             for(i=0;i<4;i++)
             {

             status=XAllocNamedColor(mydisplay,mycolormap,colorname[i],&mycolor_def, &mycolor_rgb);

             if(status != 0 )
             {
                     mycolors[num_mycolors] = mycolor_def.pixel;
                     num_mycolors++;

              }
              }

         }


        if(depth >= 8)
        {
             for(i=0;i<ncmax;i++)
             {

                  status=XAllocNamedColor(mydisplay,mycolormap,colorname[i],&mycolor_def, &mycolor_rgb);

                  if(status != 0 )
                  {
                          mycolors[num_mycolors] = mycolor_def.pixel;
                          num_mycolors++;

                  }

             }

         }
}

set_box()
{
/*
        sets xr,xl,yu,yb from xsize and ysize of the screen

*/
          xl=(int)(100.*xsize/640.);
          xr=(int)(xsize-1);

          yu=(int)(1);
          yb=(int)(280.*ysize/350.);

          /* additions to swap the map to match ps and hpgl maps */

          yb = ysize-(int)yb;
          yu = ysize-(int)yu;

}

get_size()
{

        XGetGeometry(mydisplay,mywindow,&root,
                     &main_xpos,&main_ypos,&xsize,&ysize,&border_width,&depth);

        set_box();
        
        if(debug)
        {
        	printf("get_size: window at %i,%i\n",main_xpos,main_ypos);
        	printf("get_size: size = %ix%i \n",xsize,ysize);
        }

}

save_main_config(XEvent myevent)
{
/*
	on configure notify event for main window
	saves the size and position
	
	uses a combination of XGetGeometry for size and the 
	Xevent data for location, if it seems reasonable.
*/
int xt,yt,xs,ys;	

	
	XGetGeometry(mydisplay,mywindow,&root,&main_xpos,&main_ypos,
		&xsize,&ysize,&border_width,&depth);
	
	/* the following does not seem reliable

	xs = myevent.xconfigure.width;
	ys = myevent.xconfigure.height;
	
	if( xs > 10 && ys > 10)
	{
		xsize=xs;
		ysize=ys;
	}
	
	*/
	
	xt = myevent.xconfigure.x;
	yt = myevent.xconfigure.y;
	
	if(xt != 0 && yt != 0)
	{
		main_xpos=xt;
		main_ypos=yt;
	}
		
        if(debug)
        {
        	printf("save: window at %i,%i\n",main_xpos,main_ypos);
        	printf("save: size = %ix%i \n",xsize,ysize);
        }
}

redraw(int flag)
{

        if( flag == 1)
        {
                XClearWindow(mydisplay,mywindow);
        }

/*
        get_size();
*/
        box();
        plotcurves(1);
        show_ticks();    /* includes titles */
        x_put_comments();

}

titles()
{
char data[50];
int x,y,i;

        x=1;
        y=ysize-fheight/2;
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, filecurrent, strlen(filecurrent));

        x=xl;
        y=fheight;

        convert(data,ymax);
        x=x-fwidth*(strlen(data)+2);
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, data, strlen(data));

        x=xl;
        y=x_y_coord(yb)-fheight/2;

        convert(data,ymin);
        x=x-fwidth*(strlen(data)+2);
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, data, strlen(data));

        x=xl;
        y=x_y_coord(yb)+3*fheight/2;

        convert(data,xmin);
        x=x-fwidth*strlen(data)/2;
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, data, strlen(data));

        x=xr;
        y=x_y_coord(yb)+3*fheight/2;

        convert(data,xmax);
        x=x-fwidth*strlen(data);
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, data, strlen(data));

        x=(xr+xl)/2;
        y=x_y_coord(yb)+5*fheight/2;

        if(y >= ysize ) y = ysize-fheight/2;

        x=x-fwidth*strlen(xlabel)/2;
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, xlabel, strlen(xlabel));


        x=xl-5*fwidth;
        y=x_y_coord((yb+yu)/2)-fheight*strlen(ylabel)/2;

        for(i=0;i<=strlen(ylabel);i++)
        {
        sprintf(data,"%c",ylabel[i]);
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, data, strlen(data));
        y=y+fheight;
        }
}

gf_exit()
{

        /* termination */
        
        if(mydisplay != NULL)
        {
              XFreeGC(mydisplay, mygc);
              XDestroyWindow(mydisplay, mywindow);
              XCloseDisplay(mydisplay);
        }
        exit(0);

}

lin_fit(int istart,int iend,int seg,int num,int xpos,int ypos)
{
        int row1,col1,row2,col2,i,d1,d2,d1min,d2min,n;
        float sumx,sumy,sumxx,sumyy,slope,inter,denom,xtemp,ytemp,sumxy,avex,avey;
        int x,y,x0,y0,os,t;
        char temp[100];

        sumxx = 0.;
        sumy = 0.;
        sumxy = 0.;
        sumx = 0.;

        if(num == 1) /* linear fit */
        {
               for(i=istart;i<=iend;i++)
               {
                  sumxx = sumxx + xp[i] * xp[i];
                  sumxy = sumxy + xp[i] * yp[i];
                  sumy = sumy + yp[i];
                  sumx = sumx + xp[i];
               }

               n = iend - istart + 1;
               denom = n * sumxx - sumx * sumx;

               if(denom != 0. )
               {
                     slope = (n * sumxy - sumx * sumy) / denom ;
                     inter = (sumy * sumxx - sumx * sumxy) / denom ;

                     avex = sumx/(float)n;
                     avey = sumy/(float)n;

                     xtemp = xmin; ytemp = slope * xtemp + inter;
                     x0 = x_coord(xtemp);
                     y0 = y_coord(ytemp);

                     xtemp = xmax; ytemp = slope * xtemp + inter;
                     x = x_coord(xtemp);
                     y = y_coord(ytemp);

                     wind(&x0, &y0, &x, &y, &os);

                     t=3;
                     x_color(&t);

                     if(os != 1 )
                     {
                             xy[1] = x0; xy[2] = y0 ;

                             xy[3] = x; xy[4] = y;

                             t = 2;

                             dline(t);
                      }

                      t=1;
                      x_color(&t);

                      sprintf(temp,"For %i pts: Slope = %g, intcpt = %g",n,slope,inter);
                      info_window(xpos,ypos,temp);

                      if(yes_no_window(xpos,ypos,"Append fit line onto data?",NO) == YES)
                      {

                          xtemp = xmin; ytemp = slope * xtemp + inter;
                          xp[np+1]=xtemp;
                          yp[np+1]=ytemp;
                          iv[np+1]=0;
                          np=np+1;
                          xtemp = xmax; ytemp = slope * xtemp + inter;
                          xp[np+1]=xtemp;
                          yp[np+1]=ytemp;
                          iv[np+1]=1;
                          np=np+1;
                      }

               }
               else
               {
                     info_window(xpos,ypos,"ERROR, can't fit points");
               }
        }
        else
        {
               for(i=istart;i<=iend;i++)
               {
                  sumy = sumy + yp[i];
                  sumx = sumx + xp[i];
               }

               n = iend - istart + 1;

               avex = sumx/(float)n;
               avey = sumy/(float)n;

               sprintf(temp,"For %i pts: ave X = %g, ave Y = %g",n,avex,avey);
               info_window(xpos,ypos,temp);

        }
}

fit_locate(int row,int col,int seg,int *at,int xpos,int ypos)
{
int i,k,d1,d1min,x0,y0;
float xtemp,ytemp;

        *at= 0;
        d1min = 20; /* in pixels */

        k = -1;/* current segment */

        for(i=1;i<=np;i++)
        {
             if(iv[i] <= 0 || i == 1) k++;

             if(k == seg)
             {
                xtemp=xp[i];
                ytemp=yp[i];

                x0 = x_coord(xtemp);
                y0 = y_coord(ytemp);
                y0 = x_y_coord(y0);

                d1 = abs(x0-col)+abs(y0-row);

                if(d1 < d1min)
                {
                        d1min = d1;
                        *at = i;
                }
             }

          }

          if(*at == 0 )
          {
                info_window(xpos,ypos,"Point not located");
                return(-1);
          }

         return(0);
}


usage(cmd)
     char       *cmd;
{
  fprintf(stderr, "usage: %s [-g geometry] [-d display] [filename]\n", cmd);
}


/*
*********************************************************************

            routines below here are generic to GF versions

*********************************************************************
*/

menu(int flag)
{
int q,i,x,y;

if(flag ==0)
{

      printf(" 0 \t Exit menu \n");
      printf(" 1(f) \t File form (same as 2 and 8) \n");
      printf(" 4(q) \t Quit \n");
      printf(" 5 \t Rescale \n");
      printf(" 6 \t Quick Rescale \n");
      printf(" 7 \t Add Comments \n");
      printf(" 9 \t Plot file \n");
      printf(" 10(p) \t Profile \n");
      printf(" 11(f) \t Linear Curve Fit \n");
      printf(" 12(t) \t Data transformations \n");
      printf(" 13(r) \t Re-read current file \n");

      printf(" \n");

      q=0;
      get_default_i("Command ",&q);
}
else
{
      q=flag;
}

        x = main_xpos+xsize/2;
        y = main_ypos+ysize/2;

switch(q)
{
        case 1:
                file_form(0);
                break;
         case 2:
                file_form(0);
                break;
         case 4:
                gf_exit();
                break;
         case 5:
                rescale(0);
                break;
         case 6:
                maxmin(&xmin,&xmax,&ymin,&ymax);
                redraw(1);
                break;
         case 7:
                comment_form();
                plot_lists_defaults(PLOTWIN);
                break;
         case 8:
                file_form(0);
                break;
         case 9:
                  if(num_data_segments() >= MAXSEGMENTS)
                  {
                        info_window(x,y,"Too many data segments to plot");
                  }
                  else
                  {
                    if(np>0)
                    {
                        plot_form();
                        device = 1;   /* make sure -- is also done in plot_form now */
                        set_box();   /* reset xl, xr, yu, yb to x window values */
                    }
                  }
                break;
         case 10:
                profile_form(x,y);
                break;
         case 11:
                data_form();
                plot_lists_defaults(PLOTWIN);
                break;
         case 12:
                data_form();
                plot_lists_defaults(PLOTWIN);
                break;
          case 13:
                reread();
                break;
         default:
                break;
}
}

reread()
{
/*
	rereads the current file for the 'r' command

	does nothing if multiple files have been appended
*/
char name[50];
int x,y;

        if(strchr(filecurrent,'+') != NULL) return;

        strcpy(name,filecurrent);
        
        x = main_xpos + xsize/2;
        y = main_ypos + ysize/2;
        
        read_gf(name,x,y);
        redraw(1);
}

save_gf(char *name,int xpos,int ypos)
{
FILE *gffile;
int i,len,tvlen,t;
float x,y;
char line[50],cs;
char fmt[20];
char temp[75];

len = 50;

again:

        if((gffile=fopen(name,"r")) != NULL )
        {
               fclose(gffile);

               if(yes_no_window(xpos,ypos,"File exists, Overwrite?",NO) != YES)
               {
                     return(-1); /* didn't write the file */
               }
               /* can read comments here for write below ... */

        }


        if((gffile=fopen(name,"w")) == NULL)
        {
                info_window(xpos,ypos,"Cannot open file");
                return(-1);
        }

        if((vlen==0)&&(num_data_segments() > 1))
        {
                if(yes_no_window(xpos,ypos,"Invec length is zero and have multiple data segments, continue?",NO) != YES)
                {
                        return(-1);
                }
        }

        if((use_delim==1)&&(num_data_segments() > 1))
        {
                if(yes_no_window(xpos,ypos,"Using delimiter and have multiple data segments, continue?",NO) != YES)
                {
                        return(-1);
                }
        }

        if(use_delim == 0)
        {
              if(vlen > 0)
              {
                    sprintf(fmt,"%%%ii%%+%i.%iE%%+%i.%iE\n",vlen,dlen,dlen-7,dlen,dlen-7);
               }
              else  /* default to vlen = 3 on write -- not any more */
              {
/*                    sprintf(fmt,"%%3i%%%ig%%%ig\n",dlen,dlen); */
                    sprintf(fmt,"%%+%i.%iE%%+%i.%iE\n",dlen,dlen-7,dlen,dlen-7);
              }
        }
        else  /* using delimiter no invec */
        {
                sprintf(fmt,"%%g%c%%g\n",delim_char);
        }
/*
        no comments tranfer if existing file yet...

*/

        fprintf(gffile,"%i \n",np);

        for(i=1;i<=np;i++)
        {
                if((use_delim == 0)&&(vlen > 0))
                         fprintf(gffile,fmt,iv[i],xp[i],yp[i]);
                else
                         fprintf(gffile,fmt,xp[i],yp[i]);
        }

        if(s1 == 1)
        {
              sprintf(fmt,"%%+%i.%iE%%+%i.%iEL\n",dlen,dlen-7,dlen,dlen-7);
              /*
              sprintf(fmt,"%%%ig%%%igL\n",dlen,dlen);
              */
        }
        else
        {
              sprintf(fmt,"%%+%i.%iE%%+%i.%iE\n",dlen,dlen-7,dlen,dlen-7);
              /*
              sprintf(fmt,"%%%ig%%%ig\n",dlen,dlen);
              */
        }

        fprintf(gffile,fmt,xmin,xmax);

        if(s2 == 1)
        {
              sprintf(fmt,"%%+%i.%iE%%+%i.%iEL\n",dlen,dlen-7,dlen,dlen-7);
              /*
              sprintf(fmt,"%%%ig%%%igL\n",dlen,dlen);
              */
        }
        else
        {
              sprintf(fmt,"%%+%i.%iE%%+%i.%iE\n",dlen,dlen-7,dlen,dlen-7);
              /*
              sprintf(fmt,"%%%ig%%%ig\n",dlen,dlen);
              */
        }

        fprintf(gffile,fmt,ymin,ymax);

        /*     for ticks
        sprintf(fmt,"%%c%%%ig%%%ig\n",dlen,dlen);
        */
        sprintf(fmt,"%%c%%+%i.%iE%%+%i.%iE\n",dlen,dlen-7,dlen,dlen-7);

        fputs(xlabel,gffile);
        fprintf(gffile,"\n");

        fputs(ylabel,gffile);
        fprintf(gffile,"\n");


        fprintf(gffile,fmt,ticks,xtick,ytick);

        if(num_comments > 0 )
        {
             for(i=0;i<num_comments;i++)
             {
                    len=strlen(comments[i]);
                    fputs(comments[i],gffile);
                    fprintf(gffile,"\n %i   %i\n",com_row[i],com_col[i]);              }
        }

         fclose(gffile);

         sprintf(temp,"%i points written to %s",np,name);
         info_window(xpos,ypos,temp);


/*
       erase old filename and display new one

*/
        t=0;
        x_color(&t);

        x=1;
        y=ysize-fheight/2;
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, filecurrent, strlen(filecurrent));

        strcpy(filecurrent,name);

        t=1;
        x_color(&t);

        x=1;
        y=ysize-fheight/2;
        XDrawImageString( mydisplay,mywindow, mygc,
                x, y, filecurrent, strlen(filecurrent));

}

int append_gf(char *name,int xpos,int ypos)
{
FILE *gffile;
int i,i1,len,n1,n2,nline;
float x,y;
char line[251],temp[100];

len = 250;
nline = 0;

tryagain:
        if((gffile=fopen(name,"r")) == NULL )
        {
                if(strstr(lowercase(name),".gf") == NULL)
                {
                        strcat(name,".gf");
                        goto tryagain;
                }
                else
                {
                        info_window(xpos,ypos,"File not found");
                        return(-1);
                }
        }

comment:
        fgets(line,len,gffile);
        nline++;
        if( (line[0] == 'c') || (line[0] == 'C') ) goto comment;

        if (strlen(line) < dlen )  /* check for np */
        {
             sscanf(line,"%i", &n2);
             use_eof = 0;
        }
        else
        {
                n2=npmax-np;
                use_eof = 1;
        }

        if(np+n2 > npmax )
        {
                info_window(xpos,ypos,"Too many points to append");
                fclose(gffile);
                return(-1);
        }

        if(use_eof == 0 )
        {
             fgets(line,len,gffile);
             nline++;
        }

        if(get_cols(line,xpos,ypos) == 0)
        {
                fclose(gffile);
                return(-1);
        }

        if(parse_data(line,&i1,&x,&y) == -1 )
        {
                sprintf(temp,"Error on data parsing in line %i",nline);
                info_window(xpos,ypos,temp);
                fclose(gffile);
                return(-1);
        }

        if(i1 != 1)
        {
                iv[np+1]=i1;
        }
        else
        {
                iv[np+1]=0;
        }
        xp[np+1]=x;
        yp[np+1]=y;

        for(i=2+np;i<=np+n2;i++)
        {

/*      fscanf(gffile,"%3i%10f%10f",&i1,&x,&y);  */

              fgets(line,len,gffile);
              
              if(use_eof == 1)
              {
                      if( feof(gffile))
                      {
                      	      if(parse_data(line,&i1,&x,&y) != -1 )
                      	      {
                      	      	iv[i]=i1;
                      	      	xp[i]=x;
                      	      	yp[i]=y;
                      	      	n2=i-np;
                      	      	goto at_eof;
                      	      }
                      	      
                              n2=i-np-1;
                              goto at_eof;
                      }
              }

              if(parse_data(line,&i1,&x,&y) == -1 )
              {
                      sprintf(temp,"Error on data parsing in line %i",nline);
                      info_window(xpos,ypos,temp);
                      fclose(gffile);
                      return(-1);
              }

              iv[i]=i1;
              xp[i]=x;
              yp[i]=y;
              
        }

        if(use_eof == 1)
        {
                info_window(xpos,ypos,"too many points, file truncated");
        }

at_eof:
        fclose(gffile);

        np=np+n2;

        strcat(filecurrent,"+");
        strcat(filecurrent,name);

        return 1;

}

int transform(int type,float *p1,float *p2,float *p3,float *p4,float *p5,float *p6,int seg,int
num,int n1,int xpos,int ypos) 
{
int i,n2,j,k,n3,ii,k1,i1;
float xx1,xx2,yy1,yy2,a,b,c,d,e,f,x,y;
/*
            DATA TRANSFORMATIONS

            type = 0    linear  p1,p2,p3,p4,p5,p6 on seg
            type = 1    reduce pts  num   on seg
            type = 2    smoothing win/2 = num   on seg
            type = 3    remove segment seg

            n1 = 1   append as new data

*/
        if( type == 1) goto reduce;

        if( type == 2 && (10 + np) < npmax) goto smooth;

        if( type == 3 ) goto remove;

        /* linear data tranformation */

        if( seg == 0) /* apply to all */
        {
              for(i = 1;i <= np;i++)
              {
                     iv[i + n1 * np] = iv[i];
                     x = xp[i];
                     y = yp[i];
                     xp[i + n1 * np] = *p1 * x + *p2 * y + *p3;
                     yp[i + n1 * np] = *p4 * x + *p5 * y + *p6;
              }
              np = np + n1 * np;
        }
        else
        {
              k = 0;
              k1=0;
              for(i = 1;i <= np;i++)
              {
                     if(iv[i] <= 0) k++;

                     if(k == seg)
                     {
                         if(n1 == 0)
                         {
                               iv[i] = iv[i];
                               x = xp[i];
                               y = yp[i];
                               xp[i] = *p1 * x + *p2 * y + *p3;
                               yp[i] = *p4 * x + *p5 * y + *p6;
                         }
                         else
                         {
                              k1++;
                              iv[k1+np] = iv[i];
                              x = xp[i];
                              y = yp[i];
                              xp[k1 + np] = *p1 * x + *p2 * y + *p3;
                              yp[k1 + np] = *p4 * x + *p5 * y + *p6;

                         }
                     }
              }
              np = np + k1;

        }
        return(0);

reduce:
        xy[1] = 1; j = 2;
        for(i = 2;i <= np;i++)
        {
             if( iv[i] <= 0) {xy[j] = i; j = j + 1;}
        }
        n2 = j - 1; xy[j] = np + 1;

        n1 = num;

        if(seg == 0)/* do all segments */
        {
              k = 1;
              for(j = 1;j<= n2;j++)
              {
                     n3 = xy[j + 1] - 1 ;

                     for(i = xy[j]; i <= n1 * (int)((n3 - xy[j] + 1) / n1) + xy[j] - 1;i=i+n1)
                     {
                           xp[k] = xp[i];
                           yp[k] = yp[i];
                           iv[k] = iv[i];
                           k = k + 1;
                     }
                     if( (n3 - xy[j] + 1) != n1 * (int)((n3 - xy[j] + 1) / n1) )
                     {
                           xp[k] = xp[n3]; yp[k] = yp[n3]; iv[k] = iv[n3]; k = k + 1 ;
                     }
              }
              np = k - 1;
        }
        else
        {
               k = 1;
               j = seg;
               n3 = xy[j + 1] - 1 ;

               for(i = xy[j]; i <= n1 * (int)((n3 - xy[j] + 1) / n1) + xy[j] - 1;i=i+n1)
               {
                     xp[k] = xp[i];
                     yp[k] = yp[i];
                     iv[k] = iv[i];
                     k = k + 1;
               }
               if( (n3 - xy[j] + 1) != n1 * (int)((n3 - xy[j] + 1) / n1) )
               {
                     xp[k] = xp[n3]; yp[k] = yp[n3]; iv[k] = iv[n3]; k = k + 1 ;
               }

               np = k - 1;
        }
        return(0);

smooth:

        n1=num;

        xy[1] = 1; j = 2;

        for(i = 2;i<=np;i++)
        {
             if( iv[i] <= 0){xy[j] = i; j = j + 1;}

        }

        n2 = j - 1; xy[j] = np + 1;

        if(seg == 0) /* do all segments */
        {
               for( ii = n2; ii >= 1;ii--)
               {
                    n3 = xy[ii + 1] - 1;

                    xp[n3 + n1] = xp[n3];
                    yp[n3 + n1] = yp[n3];
                    iv[n3 + n1] = iv[n3];

                    for(i = n3 - 1;i >= xy[ii] + 1;i--)
                    {
                           x = 0; y = 0; k = 0;

                           for( j = -n1;j<= n1;j++)
                           {
                                  if( i + j >= xy[ii] && i + j <= n3)
                                  {
                                         x = xp[i + j] + x;
                                         y = y + yp[i + j];
                                         k = k + 1 ;
                                   }
                            }

                            xp[i + n1] = x / k;
                            yp[i + n1] = y / k;
                            iv[i + n1] = iv[i];
                     }

                    n3 = xy[ii];
                    xp[n3 + n1] = xp[n3];
                    yp[n3 + n1] = yp[n3];
                    iv[n3 + n1] = iv[n3];
               }

               for( i = 1;i<= np;i++)
               {
                    xp[i] = xp[i + n1]; yp[i] = yp[i + n1]; iv[i] = iv[i + n1];
               }
        }
        else
        {
                info_window(xpos,ypos,"Single segment smooth not yet supported");
                return(-1);
        }
        return(0);


remove:
/* removing data segments */
       k = 1;
       for(i = 2 ;i<= np;i++)
       {
            if( iv[i] <= 0){ k = k + 1; xy[k] = i;}
       }
       xy[1] = 1;/* start of first data segment */
       xy[k + 1] = np + 1; /* end of last data segment + 1 */

       if(k == 1)
       {
                info_window(xpos,ypos,"Only one data segment, cannot remove.");
                return(-1);
       }

       k1=seg;


       if( k1 == k)
       {
                np = xy[k] - 1;
                return(0);
       }

       i1 = xy[k1 + 1] - xy[k1];/* length of data segment */

       for( i = xy[k1];i<= np - i1;i++)
       {
           xp[i] = xp[i + i1];
           yp[i] = yp[i + i1];
           iv[i] = iv[i + i1];
       }

       np=np-i1;

       return(0);

}

num_data_segments()
{
int i,k;

      k = 1;
      for( i = 2;i<=np;i++){if( iv[i] <= 0) k = k + 1;}
      return(k);
}



/*
**********************************************************************

                utility routines follow

**********************************************************************
*/

get_default_f(char *prompt,float *x)
{
char temp[50];

        printf("%s <%.4g> ? ",prompt,*x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                sscanf(temp,"%f",x);
        }

}

get_default_i(char *prompt,int *x)
{
char temp[50];

        printf("%s <%i> ? ",prompt,*x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                sscanf(temp,"%i",x);
        }

}

get_default_s(char *prompt,char *x)
{
char temp[50];

        printf("%s <%s> ? ",prompt,x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                strcpy(x,temp);
        }

}

get_default_c(char *prompt,char *x)
{
char temp[50];

        printf("%s <%c> ? ",prompt,*x);

        gets(temp);

        if (temp[0] != '\0' )
        {
                *x=temp[0];
        }

}

int sign(float x)
{
        if(x >= 0.0 )
        {
             return(1);
        }
        else return(-1);
}

void convert(char *data,float x)
{
/*
   used to put axis limit values into string data form

*/
                sprintf(data,"%.4g",x);
}

char *lowercase(char *temp)
{
int l,i;
        l=strlen(temp);
        for(i=0;i<l;i++)
        {
                temp[i]=tolower(temp[i]);
        }
        return(temp);
}

char *uppercase(char *temp)
{
int l,i;
        l=strlen(temp);
        for(i=0;i<l;i++)
        {
                temp[i]=toupper(temp[i]);
        }
        return(temp);
}


/*
**********************************************************************

                 device independant subroutines follow

                 these are just hooks to the proper device
                 dependant subroutines

          !!!!!   HPGL removed !!!!!

**********************************************************************
*/

initgraph ()
{
/*
'12005 ON dv GOTO 12100, 13000, 14000' INIT GRAPHICS

if(device ==  1 ) sinitg();   not used for x routines, yet ...
*/
/* if(device ==  2 ) hpgl_initg(); */
if(device ==  3 ) ps_initg();
}



dline (int t)
{
/*
  ' DRAW LINE 12000
*/

if( device ==  1 )  xline(t);
/* if( device ==  2 )  hpgl_line(t); */
if( device ==  3 )  ps_line(t);

}

text (int tx,int ty,char *tt,int t)
{
/*
'12020 ON dv GOTO 12300, 13100, 14100' TEXT
*/
if(device ==  1 ) xtext(tx, ty, tt, t);
/* if(device ==  2 ) hpgl_text(tx, ty, tt, t); */
if(device ==  3 ) ps_text(tx, ty, tt, t);
}

setpen (int t)
{
/*
'12040 ON dv GOTO 12080, 13020, 14020' SELECT PEN
*/
/* if(device ==  2) hpgl_setpen(t); */
if(device ==  3) ps_setpen(t);

}

penup ()
{
/*
'12050 ON dv GOTO 12080, 13060, 12080' PEN UP
*/

/* if(device ==  2 ) hpgl_penup(); */

}

pendown ()
{
/*
'12060 ON dv GOTO 12080, 13070, 12080' PEN DOWN
*/
/* if(device ==  2) hpgl_pendown(); */
}


speed (int t)
{
/*
  ' PEN SPEED

*/

/* if(device ==  2) hpgl_penspeed(t); */

}

s_set_color(int i)
{
/*

             GET NEW LINE TYPE/COLOR FOR SCREEN ONLY at 1800

             still device independant

*/
int t;

     if( device != 1) return(0);

     linetype = linetype + 1;

     if( i == 1) linetype = 1;

     if( iv[i] < 0) linetype = abs(iv[i]);

     t = linetype; ulinetype(&t); linetype=t;
}

ulinetype (int *t)
{
int t1;
t1=*t;
/*
'12030 ON dv GOTO 12600, 13080, 14080' LINE TYPE
*/

if(device ==  1) x_color(&t1);
/* if(device ==  2) hpgl_linetype(&t1); */
if(device ==  3) ps_linetype(&t1);

*t=t1;
}

setcolor(int t)
{
        if(device == 3) ps_color(t);
}

int get_strlen(char *text)
{
if(device == 1 ) return(strlen(text));
if(device == 2 ) return(strlen(text));
if(device == 3 ) return(ps_strlen(text));
}

/*
  ********************************************************************

                      X specific drawing routines follow
                  that are called from device indep routines

                  device = 1

  ********************************************************************
*/

xline (int t)
{
int i;
        for(i=2;i<=t;i++)
        {
             XDrawLine(mydisplay,mywindow,mygc,xy[2*i-3],x_y_coord(xy[2*i-2]),xy[2*i-1],x_y_coord(xy[2*i]));
        }
}

int x_y_coord(int y)
{
/*
  convert from y=0 at bottom to at top
*/
int y1;
        y1=(int)yu-y+1;

        return(y1);
}

xlinetype(int t)
{

        /* line attributes */

        line_width=t;
        line_style=LineSolid;
        cap_style=CapButt;
        join_style=JoinMiter;
        XSetLineAttributes(mydisplay,mygc,line_width,line_style,cap_style,join_style);

}


xtext(int x,int y,char *tt,int t)
{
char data[5];
int i;

        y=x_y_coord(y);    /* convert */

        if(t = 0 )
        {
        XDrawImageString(mydisplay,mywindow,mygc,
                x,y,tt,strlen(tt));
        }
        if(t = 90)
        {
              for(i=0;i<=strlen(tt);i++)
              {
              sprintf(data,"%c",tt[i]);
              XDrawImageString( mydisplay,mywindow, mygc,
                      x, y, data, strlen(data));
              y=y+fheight;
              }
        }
}


int x_color(int *tcolor)
{
/*
        colors have to be set up using set_colors first

*/
/*      background color   */
        if(*tcolor == 0)
        {
                XSetForeground(mydisplay, mygc, mybackground);
                return(1);
        }

        if(*tcolor > num_mycolors) *tcolor = 1;

        if(*tcolor <= num_mycolors)
        {
                XSetForeground(mydisplay, mygc, mycolors[*tcolor-1]);
        }

        return(*tcolor);

}


plot_close_device ()
{
/*
13597 REM
13598 REM  CLOSE COMM PORT
13599 REM
*/
        fclose(fileprt);
}

plot_open_device (char *b)
{
/*
only opens a file for now


13497 REM
13498 REM  OPEN SERIAL COMM PORT, SET PLOTTER LIMITS, NUMBER OF PENS
13499 REM
*/
/*    moved earlier ... userposition etc may change these befor this sub is called
xl = 1607; xr = 10300; yu = 7650; yb = 1467;
*/

        fileprt=fopen(b,"wt");
        if(fileprt == NULL)
        {
                printf("Error on plot output file open \n");
                return(-1);
        }
        else return(0);

}

plot_out (char *p)
{
/*
'
  '   output to file/printer
'
*/
        fprintf(fileprt,"%s \n",p);
}

plot_rotate (int *tx,int *ty)
{
/*
13697 REM
13698 REM    APPLY ROTATION MAP IF rotp = 'Y'
13699 REM
*/
int tt;
        if( rotp == 'y' || rotp == 'Y')
        {
              tt = 10300 - *ty; *ty = *tx;  *tx = tt;
        }
}
