
/* needs the following global variables */

Display mydisplay;
Window mywindow; /* the main app window if MAIN_EVENTS defined */

int main_xcen,main_ycen; /* center of the main app window */

int debug; /* =1 for debugging output */

/* to account for WM borders in window position */
#define WM_TITLEBAR_HEIGHT 21
#define WM_BORDER_WIDTH 4

/* window number in the inputwin structure */
#define GENERIC_WIN 0

/* define the following if main window event loop should be included */
#define MAIN_EVENTS


generic_form()
{
/*
                generic xinput event loop

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                returns the button pressed and the updated text (in place)
                      and the updated list items

                includes event loop with redraw and resize

                needs the redraw for the main window added.
                keys and clicks in main window ring the bell

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw
                
                keeps track of its position for next open
                
                assumes global variables
                	main_xcen
                	main_ycen
                are the center of the app's main window

*/

int done,i,in,q,win;
static int xpos = -1; /* current window position */
static int ypos = -1;
int col,row;
char txt[20];

/* declarations for second window  */

Window g_window;
GC g_gc;
XEvent g_event;

        win = GENERIC_WIN; /* window number in the structure */

        put_GENERIC_form(win);   /* fill structure with current values */
        
        GENERIC_disables(win); /* check for disables */

        if(xpos == -1 && ypos == -1)
        {
        	xpos = main_xcen - inputwin[win].xsize/2;
        	ypos = main_ycen - inputwin[win].ysize/2;
        	if(debug)
        		printf("generic init pos: %i %i \n",xpos,ypos);
	}        	

         open_input_window(&g_window,&g_gc,xpos,ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */
            XNextEvent(mydisplay, &g_event);
            
            /* redraw main window */
#ifdef MAIN_EVENTS            
            if(g_event.xany.window == mywindow)
            {
                switch(g_event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(g_event.xexpose.count == 0)
                              {
                                        redraw(0);
                              }

                        break;

                        case ConfigureNotify:
                                save_main_config(g_event);
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                              XRefreshKeyboardMapping(&g_event.xmapping);
                        break;

                        /* mouse-button presses in main beep */
                        case ButtonPress:
                                XBell(mydisplay,100);
                        break;

                        /* keyboard input in main is a beep */
                        case KeyPress:
                                XBell(mydisplay,100);
                        break;
                }
            }
#endif            
            /* events for input window */
            if(g_event.xany.window == g_window)
            {
                switch(g_event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(g_event.xexpose.count == 0)
                                        redraw_inwin(g_window,g_gc,win);

                        break;

                        case LeaveNotify:
                               redraw_inwin(g_window,g_gc,win);
                               q = -1;
                        break;
                        
                        case ConfigureNotify:
				save_position(g_event,&xpos,&ypos);
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(g_event.xmotion.x,g_event.xmotion.y,win) )
                                        {
                                             redraw_inwin(g_window,g_gc,win);
                                             q = -1;
                                        }
                                 }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&g_event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=g_event.xmotion.x;
                                    row=g_event.xmotion.y;

                                    /* check input boxes */

                                    in = check_input(win,row,col);
                                    if( in > -1 )
                                    {
                                         if(get_input(g_window,g_gc,in,win) >= 0 )
                                         {
                                        /* code to do on input change goes next */
                                               GENERIC_disables(win);
                                               redraw_inwin(g_window,g_gc,win);
                                          }
                                          else
                                          {
                                               redraw_inwin(g_window,g_gc,win);
                                          }
                                      }

                                      /* check list arrows */

                                      in = check_list(win,row,col);
                                      if( in > -1 )
                                      {
                                     /* code to do on list change goes next */
                                                GENERIC_lists_coord(win,in);
                                                get_GENERIC_form(win);
                                                GENERIC_disables(win);
                                                redraw_inwin(g_window,g_gc,win);
                                      }

                                      q=check_button(g_window,g_gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /*  button  0 */
                                           get_GENERIC_form(win);
                                          
                                       
                                      }

                                      if(q == 1)
                                      {
                                       /* button 1 */
                                         

                                      }

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &g_event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if( mykey == XK_Escape ) done = 2;

                                if( (mykey == XK_Return) || (mykey == XK_KP_Enter) || (mykey == XK_Linefeed))
                                {
                                   /* do defaults ...  */
                                     get_GENERIC_form(win);
                                     GENERIC_disables(win);
                                 
                                     done = 1;    
                                }

                        break;
                } /* switch(g_event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(g_window,g_gc);

        return(done);
}

get_GENERIC_form()
{
/* gets info from the form structures into global variables */


}

put_GENERIC_form()
{
/* puts the info from the global variables into the form structures */

}

GENERIC_lists_coord()
{
/* does any interactions between the list boxes on the form */

}

GENERIC_disables()
{
/* does any disabling based on the global variables of the form structures */

}

GENERIC_lists_defaults()
{
/* sets the defaults on the list */

}

/* only need one copy of the following */

save_position(XEvent event,int *xpos,int *ypos)
{
/*
	saves the current window position (corrected for WM border)
	if the ConfigureNotify event has position info
	
	set the defines to match your WM settings (4,21 work for me)
*/	
int x,y;

        x = event.xconfigure.x;
        y = event.xconfigure.y;
        if( x != 0 && y != 0)
        {
               *xpos = x - WM_BORDER_WIDTH;
               *ypos = y - WM_TITLEBAR_HEIGHT;
               if(debug)
                      printf("Button set pos: %i %i \n",*xpos,*ypos);
        }                        

}

save_main_config(XEvent event)
{
/*
        keeps track of the main window position and size
        
        pass it a ConfigureNotify event

*/
int xt,yt;
        xsize=event.xconfigure.width;
        ysize=event.xconfigure.height;
        xt=event.xconfigure.x;
        yt=event.xconfigure.y;
        if(xt != 0 && yt != 0)
        {
                main_xcen = xt + xsize/2;
                main_ycen = yt + ysize/2;
        }
        
        if(debug)
        {
        	printf("set_box: center = %i %i \n",main_xcen,main_ycen);
        }

        inputwin[MAIN_WIN].xsize=xsize;
        inputwin[MAIN_WIN].ysize=ysize;

}

